function [dLu,dLm,dLc,dLd] = gradient(P,ALu,ALm,R_bar,lrn_ratings,u2ml,m2ul,N,Nu,Nm,K,L)

rdu = zeros(L,K,N);
rdm = zeros(L,K,N);

for ii = 1:N
    temp = (R_bar(ii) - lrn_ratings(ii))*((1:K)-R_bar(ii))'.*P(:,ii);
    for jj = 1:K
        rdu(:,jj,ii) = temp(jj) .* ALm(:,jj,ii);
        rdm(:,jj,ii) = temp(jj) .* ALu(:,jj,ii);
    end
end

dLu = zeros(L,K,Nu);
for ii = 1:Nu
    dLu(:,:,ii) = sum(rdu(:,:,u2ml{ii}),3);
end

dLm = zeros(L,K,Nm);
for ii = 1:Nm
    dLm(:,:,ii) = sum(rdm(:,:,m2ul{ii}),3);
end

dLc = sum(rdu,3);
dLd = sum(rdu,3);

end

